import BoqiiAuth from "./auth";
import Utils from '../public/common';

let auth = new BoqiiAuth();

let ApiUrl = 'http://api.boqii.com/weixin/js_config';
if(Utils.isDevelopment()){
    ApiUrl = 'http://api-dev.boqii.com/weixin/js_config';
};

const noop = function(){};

/**
 * url: 本页面的 url (需要处理下)
 * title: 分享标题
 * link: 分享链接
 * imgUrl: 分享头图
 * desc: 描述
 * success: 分享成功后回调
 * cancel: 分享失败后回调
 */

function wex_config(url='http://m.boqii.com', { title='波奇宠物', link='', imgUrl='', desc='波奇宠物'}, success=noop, cancel=noop){
    url = url.split('#')[0];
    link === '' && link = url;

    var sdata = {
      url
    };
    $.ajax({
      url:ApiUrl,
      type:"get",
      data:sdata,
      async:false,
      debug:true,
      headers: {
        'Sign': auth.signParams(sdata),
        'Authorization': "",
        'Vary-Client': 'web'
      },
      success:function(data){
        // 微信配置
        wx.config(data.ResponseData);
        wx.ready(function () {
          // 分享朋友圈
          wx.onMenuShareTimeline({
            title,
            link,
            imgUrl,
            success,
            cancel
          });
          // 分享给朋友
          wx.onMenuShareAppMessage({
            title,
            desc,
            link,
            imgUrl,
            success, 
            cancel
          });
        });
      }
    });  

}

export default wex_config;
