import $ from 'zepto';
import UI from './ui';
import Utils from './utils';
import { getShopApi } from '../libs/config';
import hex_md5 from '../libs/md5';

function device(){
	var source = Utils.GetQueryString('source');
	if( source === 'h5' ){
		return 'H5';
	}else{
		return 'APP';
	}
}
 let EVENT_ID = (Utils.isDevelopment()) ? "57a827813700621d643fbcf9" : "57a82e806c7a158256a75bd0";
 if(Utils.isDevelopment()){
 	window.shopUrl="http://stest.boqii.com/";
 }else{
 	window.shopUrl="http://s.boqii.com/";
 }
// 用户登陆逻辑处理
$(document).on('tap','#loginBtn',function(){
	let $loginContainer = $('div#login');
	let name = $loginContainer.find('#UserName').val();
	let passwd = $loginContainer.find('#Password').val();
	var source = Utils.GetQueryString('source');
	
	if( name === '' || passwd === '' ){
		UI.tips('请填写完整');
		return;
	}

	// ajax 请求
	var param = {
	    "Act": "UserLogin",
	    "UserName": name,
	    "Password": hex_md5(passwd)
	};

	$.ajax({
        type: "post",
        dataType: "json",
        data: param,
        url: getShopApi() + "/vetapi.php",
        success: function (data) {
          	var receive_data = data.ResponseData;

			if( data.ResponseStatus == 0 ){
				UI.tips('登陆成功!');
				localStorage.hasUserId = 1;
				if( device() === 'H5' ){ // 浏览器或微信
					let domain = '.boqii.com';
					Utils.storageInfo('cookie').set( "vUserId", receive_data.UserId, undefined, "/", domain );
					Utils.storageInfo('cookie').set( "vHasPayPassword", receive_data.HasPayPassword, undefined, "/", domain );
					Utils.storageInfo('cookie').set( "vBalance", receive_data.Balance, undefined, "/", domain );
					Utils.storageInfo('cookie').set( "vTelephone", receive_data.Telephone, undefined, "/", domain );
					localStorage.UserId = receive_data.UserId;
				}else{ // APP 同步登陆
					if( Utils.Device() === 'IOS' ){
						window.location.href = encodeURIComponent("bqloginprotocol" + receive_data.UserId + "bqloginprotocol");
						// app 自动刷新
						setTimeout(function(){
							var href = window.location.href.replace('&UserId=','');
							window.location.href = href+"&UserId="+encodeURIComponent(receive_data.UserId);
						},500);
					}else if( Utils.Device() === 'ANDROID' ){
						var jsonStr = JSON.stringify(receive_data);
						Boqii.Login(jsonStr, name);
						// app 自动刷新
						setTimeout(function(){
							var href = window.location.href.replace('&UserId=','');
							window.location.href = href+"&UserId="+encodeURIComponent(receive_data.UserId);
						},500);
					}
					setTimeout(function(){
						var href = window.location.href.replace('&UserId=','');
						window.location.href = href+"&UserId="+encodeURIComponent(receive_data.UserId);
					},500);
				}

				//1s后 关闭弹框
				setTimeout(function(){
					$('.pupWindow').remove();
					$(".mask,.fail").show();
				},1000);

			}else{
				UI.tips(data.ResponseMsg);
        	}
        }
    });
});

// 用户注册逻辑处理
$(document).on('tap','#registerBtn',function(){
	let $loginContainer = $('div#register');
	let name = $loginContainer.find('#UserName').val();
	let passwd = $loginContainer.find('#Password').val();
	let t_yzm = $loginContainer.find('#t_yzm').val(); // 图形验证码
	let yzm = $loginContainer.find('#yzm').val(); // 验证码

	if( name === '' || passwd === '' || t_yzm === '' || yzm === '' ){
		UI.tips('请填写完整信息');
		return;
	}

	var source = Utils.GetQueryString('utm_source') || ""; 

	// ajax 请求
	var param = {
        "Act":"UserRegister",
        "UserName":name,
        "Password":hex_md5(passwd),
        "AuthCode":yzm,
        "IsNew": 1,
	    "H5Channel":source,
	    "H5ActivityId":EVENT_ID
    };

    $.ajax({
		type: "post",
		dataType: "json",
		data: param,
		url: getShopApi() + "/vetapi.php",
		success: function (data) {
			var receive_data = data.ResponseData;
			if (data.ResponseStatus == 0) {
				UI.tips('注册成功!'); // 注册成功同时也 登陆成功
				localStorage.hasUserId = 1;
				//receiveQuan();
				if( device() === 'H5' ){ // 浏览器或微信
					let domain = '.boqii.com';
					Utils.storageInfo('cookie').set( "vUserId", receive_data.UserId, undefined, "/", domain );
					Utils.storageInfo('cookie').set( "vTelephone", name, undefined, "/", domain );

				}else{ // APP 同步登陆
					if( Utils.Device() === 'IOS' ){
						window.location.href = encodeURIComponent("bqloginprotocol" + receive_data.UserId + "bqloginprotocol");
						// app 自动刷新
						setTimeout(function(){
							var href = window.location.href.replace('&UserId=','');
							window.location.href = href+"&UserId="+encodeURIComponent(receive_data.UserId);
						},500);
					}else if( Utils.Device() === 'ANDROID' ){
						var jsonStr = JSON.stringify(receive_data);
						Boqii.Login(jsonStr, name);
						// app 自动刷新
						setTimeout(function(){
							var href = window.location.href.replace('&UserId=','');
							window.location.href = href+"&UserId="+encodeURIComponent(receive_data.UserId);
						},500);
					}
					
				}
				//1s后 关闭弹框
				setTimeout(function(){
					$('.pupWindow').remove();
					$(".mask,.succ").show();
				},1000);

			} else {
				$('.yanzheng_imgs').trigger('tap');
				UI.tips(data.ResponseMsg);
			}
		}
    });
	
});

//获取验证码
$(document).on('tap','.getYzm',function(){
	let $loginContainer = $('div#register');
	var tel = $loginContainer.find("#UserName").val();
	var pwd = $loginContainer.find("#Password").val();

	var yzm = $loginContainer.find("#yzm").val();
	var t_yzm = $loginContainer.find("#t_yzm").val();

	if(t_yzm == ""){
		UI.tips("图形验证码不能为空！");
		return false;
	}

	if( tel.length!=11 ){
		UI.tips("您输入的手机号码格式不正确！");
		return false;
	}
	
	var seconds = 120;
    var timer = setInterval(function(){
      seconds--;

      if(seconds <= 0){
        clearInterval(timer);
        $(".getYzm").attr("disabled",false).removeClass("disabled").text("重新获取");
      }else{
        $(".getYzm").text(seconds+"秒后重新获取");
      }

    },1000);
    var code_param={
      "Act":"SendAuthCode",
      "Account":tel,
      "ImgCode":t_yzm
    }
    $.ajax({
      type:"post",
      dataType:"json",
      data:code_param,
      url:getShopApi() + "/vetapi.php",
      success:function(data){
        if(data.ResponseStatus != 0){
          UI.tips(data.ResponseMsg);
          $('.yanzheng_imgs').trigger('tap');
          clearInterval(timer);
        }
        console.log(data);
      }
    });

});

// 关闭弹框
$(document).on('tap','.back',function(){
	$('.pupWindow').remove();
});

// 从 登陆切换到 注册
$(document).on('tap','.loginRegister',function(){
	$('.pupWindow').remove();
	UI.register_layer();
});
// 从 注册切换到 登陆
$(document).on('tap','.registerLogin',function(){
	$('.pupWindow').remove();
	UI.login_layer();
});



//更换验证码
$(document).on('tap','.yanzheng_imgs',function(){
	var code_url = `${getShopApi()}/vetapi.php?Act=getVetImg&time=${new Date().getTime()}`;
	$(this).attr("src",code_url);
});

//忘记密码
$(document).on('tap','.pupWindow .forget',function(){
	window.location.href=`${shopUrl}find_password.html?from=activity`;
});


var isDevelopment  = function(){
  return !!(window.location.host.match(/localhost|vtest.boqii.com|stest.boqii.com|mtest.boqii.com|slocal.boqii.com|127\.0\.0\.1/))
}
//领券
var receiveQuan = function(){
	let $loginContainer = $('div#register');
 	let tel = $loginContainer.find('#UserName').val();
 	let vapiUrl = (isDevelopment()) ? "http://mtest.boqii.com/vetapi.php" : "http://m.boqii.com/vetapi.php";
    var param = {
    "Act": "sendCommonDiscountForH5",
    "StrActivity": EVENT_ID,
    "Mobile":tel
    };
    $.ajax({
        type: "post",
        dataType: "json",
        data: param,
        url: vapiUrl,
        success:function(data){
        	if(data.ResponseStatus==0){
        		$(".mask,.succ").show();
        	}else{
        		UI.tips(data.ResponseMsg);
        	}
        }
    });

  }
