var config = require('./config');

var gulp = require('gulp'),
    cheerio = require('gulp-cheerio'),
    upload = require('gulp-qndn').upload;

var qnOptions = {
  accessKey: config.qiniu.accessKey,
  secretKey: config.qiniu.secretKey,
  bucket: config.qiniu.bucket,
  domain: config.qiniu.domain
};

gulp.task('upload2qn_js', function () {
  return gulp.src(['release/js/*.js'])
    .pipe(upload({qn: qnOptions,prefix: 'js'}))
    .pipe(gulp.dest('release/js'));
});

gulp.task('upload2qn_css', function () {
  return gulp.src(['release/css/*.css'])
    .pipe(upload({qn: qnOptions,prefix: 'css'}))
    .pipe(gulp.dest('release/css'));
});


gulp.task('removeDebugScripts', function () {
  return gulp
    .src(['release/*.html'])
    .pipe(cheerio(function ($, file) {
      $("[data-debug]").remove();

    }))
    .pipe(gulp.dest('release/'));
});

gulp.task('addHttpTag', function () {
  return gulp
    .src(['release/*.html'])
    .pipe(cheerio(function ($, file) {

      var $link = $( 'link' );
      $link.each(function(){
        var linksrc = $(this).attr( 'href' );
        $(this).attr( 'href', "http://" + linksrc );
      });
      
      var $script = $( 'script' );

      $script.each(function(){
        if( $(this).attr('data-fixed') != '' ){
          var scriptsrc = $(this).attr( 'src' );
          $(this).attr( 'src', "http://" + scriptsrc );
        }
      })

    }))
    .pipe(gulp.dest('release/'));
});

gulp.task('clearScript',['removeDebugScripts']);

gulp.task('default',
  [
    'addHttpTag',
    'upload2qn_js',
    'upload2qn_css',
  ]);
